#!/usr/bin/env sh

CWD=$(pwd)

echo "checking kernel version..."
uname -a
if [ -e /proc/version ] ; then cat /proc/version ; fi
echo ""

while [ ! $(pwd) = "/" ] && [ $( ls | grep -c "modules\|tools\|lib" ) -lt 3 ]; do cd .. ; done
echo "checking configured \"rrdtool\" version..."
BINPATH=""
if [ -e settings ] ; then . settings ; fi
if [ "$BINPATH" = "" ] && [ -e ../settings ] ; then . ../settings ; fi
if [ "$BINPATH" = "" ] && [ -e ../../settings ] ; then . ../../settings ; fi
if [ "$BINPATH" = "" ] && [ -e ../../../settings ] ; then . ../../../settings ; fi
if [ "$BINPATH" = "" ]; then
  echo "BINPATH variable not configured in main settings!"
  echo "Check installation or call me from somewhere inside HotSaNIC!"
else
  if [ -e $BINPATH/rrdtool ]; then
    echo "using rrdtool binary in \"$BINPATH\""
    $BINPATH/rrdtool | grep Copyright
  else
    echo "no \"rrdtool\" binary found in \"$BINPATH\""
    fi
  fi
echo ""

